%
% This file is part of Rheolef.
%
% Copyright (C) 2000-2018 Pierre Saramito 
%
% Rheolef is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 2 of the License, or
% (at your option) any later version.
%
% Rheolef is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with Rheolef; if not, write to the Free Software
% Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
% -------------------------------------------------------------------------
% ------------------------------------------------------
\chapter{Matrix-vector linear system}
% ------------------------------------------------------
\section{Numerical resolution}
By elimination the fixed degrees of freedom on
the boundary, we obtain:
\[
  	(\lambda M + K) u = f
\]
or
\[
  	A u = f
\]
We split the unkown degrees of freedom (dof) set into:
\begin{itemize}
  \item unkown dof that are internal to elements : $u_i$
  \item unkown dof that are on inter-element boundaries : $u_e$
\end{itemize}
This splitting affects also matrices:
\[
    \left( \begin{array}{cc}     
        A_{ii} & A_{ie} \\
        A_{ei} & A_{ee}
    \end{array} \right)
    \left( \begin{array}{c}     
        u_i \\ u_e
    \end{array} \right)
    =
    \left( \begin{array}{c}     
        f_i \\ f_e
    \end{array} \right)
\]
The $A_{ii}$ is block diagonal and non-singular :
\[
	u_i = A_{ii}^{-1} (f_i - A_{ie} u_e)
\]
The system reduces to inter-element boundaries dof:
\[
	(A_{ee} - A_{ei} A_{ii}^{-1} A_{ie} u_e = f_e -  A_{ii}^{-1} f_i
\]
The reduces matrix
\[
    C = A_{ee} - A_{ei} A_{ii}^{-1} A_{ie}
\]
is called the Schur complement matrix.

\section{Direct resolution}

  We invert the local $A_{ii}^{-1}(K)$  matrices
  and obtain the $A_{ii}^{-1}$.
  Then, we form explicitely the Schur complement $C$ and the
  right hand side:
  \[
    g  = f_f  -      A_{ii}^{-1} f_i
  \]
  and finally solve:
  \[
    C*u_f = g
  \]
\section{Iterative resolution}
  When using a classical (GC, GEMRES, ...) iterative method, 
  we only need formal matrix-vector products involving
  $C$.
  We do not need to invert explictely the local
  $A_{ii}(K)$ : we only need to solve some local systems
  of the form:
  \[
  	A_{ii}(K)  w_i (K) = h_i(K)
  \]
  There is two solutions:
  \begin{itemize}
  \item either factorise one time for all the $A_{ii}(K)$
  \item or  iteratively solve all the local ssubsystems
  \end{itemize}
  We need to study the preconditionners
  \begin{itemize}
  \item at the global level
  \item at the local level
  \end{itemize}
  The global preconditionner involving a $P_1$ finite element 
  based on the spectral map is a good starting point.
  We need to split into subdomains related to spectral elements.

